Index: squid/src/refresh.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/refresh.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/refresh.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/refresh.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,7 +1,7 @@
 
 
 /*
- * $Id: refresh.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: refresh.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 22    Refresh Calculation
  * AUTHOR: Harvest Derived
@@ -41,7 +41,7 @@
 #include "squid.h"
 
 typedef enum {
-    rcHTTP, rcICP, rcCDigest, rcStore, rcCount
+    rcHTTP, rcICP, rcHTCP, rcCDigest, rcStore, rcCount
 } refreshCountsEnum;
 
 static struct RefreshCounts {
@@ -299,6 +299,12 @@
 }
 
 int
+refreshCheckHTCP(const StoreEntry * entry, request_t * request)
+{
+    return refreshCheck(entry, request, 10, &refreshCounts[rcHTCP]);
+}
+
+int
 refreshCheckDigest(const StoreEntry * entry, time_t delta)
 {
     return refreshCheck(entry,
@@ -328,7 +334,6 @@
     storeAppendPrintf(sentry, "Category\tCount\t%%Total\n");
 
 #define refreshCountsStatsEntry(name) { \
-    if (rc->name || !strcmp(#name, "total")) \
 	storeAppendPrintf(sentry, "%s\t%6d\t%6.2f\n", \
 	    #name, rc->name, xpercent(rc->name, tot)); \
     sum += rc->name; \
@@ -350,6 +355,7 @@
     tot = sum;			/* paranoid: "total" line shows 100% if we forgot nothing */
     refreshCountsStatsEntry(total);
     /* maybe counters */
+    storeAppendPrintf(sentry, "\n");
     refreshCountsStatsEntry(request_reload_ignore_maybe);
     refreshCountsStatsEntry(response_lmt_future_maybe);
 }
@@ -380,11 +386,12 @@
 }
 
 void
-refreshInit()
+refreshInit(void)
 {
     memset(refreshCounts, 0, sizeof(refreshCounts));
     refreshCounts[rcHTTP].proto = "HTTP";
     refreshCounts[rcICP].proto = "ICP";
+    refreshCounts[rcHTCP].proto = "HTCP";
     refreshCounts[rcStore].proto = "On Store";
     refreshCounts[rcCDigest].proto = "Cache Digests";
 
Index: squid/src/send-announce.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/send-announce.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/send-announce.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/send-announce.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: send-announce.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: send-announce.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 27    Cache Announcer
  * AUTHOR: Duane Wessels
@@ -72,10 +72,10 @@
     sndbuf[0] = '\0';
     snprintf(tbuf, 256, "cache_version SQUID/%s\n", version_string);
     strcat(sndbuf, tbuf);
-    assert(Config.Port.http);
+    assert(Config.Sockaddr.http);
     snprintf(tbuf, 256, "Running on %s %d %d\n",
 	getMyHostname(),
-	(int) Config.Port.http->i,
+	(int) ntohs(Config.Sockaddr.http->s.sin_port),
 	(int) Config.Port.icp);
     strcat(sndbuf, tbuf);
     if (Config.adminEmail) {
@@ -88,7 +88,7 @@
     strcat(sndbuf, tbuf);
     l = strlen(sndbuf);
     if ((file = Config.Announce.file) != NULL) {
-	fd = file_open(file, O_RDONLY, NULL, NULL, NULL);
+	fd = file_open(file, O_RDONLY);
 	if (fd > -1 && (n = read(fd, sndbuf + l, BUFSIZ - l - 1)) > 0) {
 	    fd_bytes(fd, n, FD_READ);
 	    l += n;
Index: squid/src/snmp_agent.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/snmp_agent.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/snmp_agent.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/snmp_agent.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: snmp_agent.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: snmp_agent.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 49     SNMP Interface
  * AUTHOR: Kostas Anagnostakis
@@ -48,37 +48,29 @@
 variable_list *
 snmp_sysFn(variable_list * Var, snint * ErrP)
 {
-    variable_list *Answer;
-
+    variable_list *Answer = NULL;
     debug(49, 5) ("snmp_sysFn: Processing request:\n", Var->name[LEN_SQ_SYS]);
     snmpDebugOid(5, Var->name, Var->name_length);
-
-    Answer = snmp_var_new(Var->name, Var->name_length);
     *ErrP = SNMP_ERR_NOERROR;
-
     switch (Var->name[LEN_SQ_SYS]) {
     case SYSVMSIZ:
-	Answer->val_len = sizeof(snint);
-	Answer->val.integer = xmalloc(Answer->val_len);
-	Answer->type = ASN_INTEGER;
-	*(Answer->val.integer) = store_mem_size >> 10;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    store_mem_size >> 10,
+	    ASN_INTEGER);
 	break;
     case SYSSTOR:
-	Answer->val_len = sizeof(snint);
-	Answer->val.integer = xmalloc(Answer->val_len);
-	Answer->type = ASN_INTEGER;
-	*(Answer->val.integer) = store_swap_size;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    store_swap_size,
+	    ASN_INTEGER);
 	break;
     case SYS_UPTIME:
-	Answer->val_len = sizeof(snint);
-	Answer->val.integer = xmalloc(Answer->val_len);
-	Answer->type = SMI_TIMETICKS;
-	*(Answer->val.integer) = tvSubDsec(squid_start, current_time) * 100;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    tvSubDsec(squid_start, current_time) * 100,
+	    SMI_TIMETICKS);
 	break;
     default:
 	*ErrP = SNMP_ERR_NOSUCHNAME;
-	snmp_var_free(Answer);
-	return (NULL);
+	break;
     }
     return Answer;
 }
@@ -86,64 +78,58 @@
 variable_list *
 snmp_confFn(variable_list * Var, snint * ErrP)
 {
-    variable_list *Answer;
+    variable_list *Answer = NULL;
     char *cp = NULL;
-    char *pp = NULL;
     debug(49, 5) ("snmp_confFn: Processing request with magic %d!\n", Var->name[8]);
-
-    Answer = snmp_var_new(Var->name, Var->name_length);
     *ErrP = SNMP_ERR_NOERROR;
-
     switch (Var->name[LEN_SQ_CONF]) {
     case CONF_ADMIN:
+	Answer = snmp_var_new(Var->name, Var->name_length);
 	Answer->type = ASN_OCTET_STR;
 	Answer->val_len = strlen(Config.adminEmail);
 	Answer->val.string = (u_char *) xstrdup(Config.adminEmail);
 	break;
     case CONF_VERSION:
+	Answer = snmp_var_new(Var->name, Var->name_length);
 	Answer->type = ASN_OCTET_STR;
 	Answer->val_len = strlen(appname);
 	Answer->val.string = (u_char *) xstrdup(appname);
 	break;
     case CONF_VERSION_ID:
-	pp = SQUID_VERSION;
+	Answer = snmp_var_new(Var->name, Var->name_length);
 	Answer->type = ASN_OCTET_STR;
-	Answer->val_len = strlen(pp);
-	Answer->val.string = (u_char *) xstrdup(pp);
+	Answer->val_len = strlen(SQUID_VERSION);
+	Answer->val.string = (u_char *) xstrdup(SQUID_VERSION);
 	break;
     case CONF_STORAGE:
 	switch (Var->name[LEN_SQ_CONF + 1]) {
 	case CONF_ST_MMAXSZ:
-	    Answer->val_len = sizeof(snint);
-	    Answer->val.integer = xmalloc(Answer->val_len);
-	    Answer->type = ASN_INTEGER;
-	    *(Answer->val.integer) = (snint) Config.memMaxSize >> 20;
+	    snmp_var_new_integer(Var->name, Var->name_length,
+		(snint) Config.memMaxSize >> 20,
+		ASN_INTEGER);
 	    break;
 	case CONF_ST_SWMAXSZ:
-	    Answer->val_len = sizeof(snint);
-	    Answer->val.integer = xmalloc(Answer->val_len);
-	    Answer->type = ASN_INTEGER;
-	    *(Answer->val.integer) = (snint) Config.Swap.maxSize >> 10;
+	    snmp_var_new_integer(Var->name, Var->name_length,
+		(snint) Config.Swap.maxSize >> 10,
+		ASN_INTEGER);
 	    break;
 	case CONF_ST_SWHIWM:
-	    Answer->val_len = sizeof(snint);
-	    Answer->val.integer = xmalloc(Answer->val_len);
-	    Answer->type = ASN_INTEGER;
-	    *(Answer->val.integer) = (snint) Config.Swap.highWaterMark;
+	    snmp_var_new_integer(Var->name, Var->name_length,
+		(snint) Config.Swap.highWaterMark,
+		ASN_INTEGER);
 	    break;
 	case CONF_ST_SWLOWM:
-	    Answer->val_len = sizeof(snint);
-	    Answer->val.integer = xmalloc(Answer->val_len);
-	    Answer->type = ASN_INTEGER;
-	    *(Answer->val.integer) = (snint) Config.Swap.lowWaterMark;
+	    snmp_var_new_integer(Var->name, Var->name_length,
+		(snint) Config.Swap.lowWaterMark,
+		ASN_INTEGER);
 	    break;
 	default:
 	    *ErrP = SNMP_ERR_NOSUCHNAME;
-	    snmp_var_free(Answer);
-	    return (NULL);
+	    break;
 	}
 	break;
     case CONF_LOG_FAC:
+	Answer = snmp_var_new(Var->name, Var->name_length);
 	if (!(cp = Config.debugOptions))
 	    cp = "None";
 	Answer->type = ASN_OCTET_STR;
@@ -152,8 +138,7 @@
 	break;
     default:
 	*ErrP = SNMP_ERR_NOSUCHNAME;
-	snmp_var_free(Answer);
-	return (NULL);
+	break;
     }
     return Answer;
 }
@@ -161,111 +146,92 @@
 variable_list *
 snmp_meshPtblFn(variable_list * Var, snint * ErrP)
 {
-    variable_list *Answer;
+    variable_list *Answer = NULL;
     struct in_addr *laddr;
     char *cp = NULL;
     peer *p = NULL;
     int cnt = 0;
     debug(49, 5) ("snmp_meshPtblFn: peer %d requested!\n", Var->name[LEN_SQ_MESH + 3]);
-
-    Answer = snmp_var_new(Var->name, Var->name_length);
     *ErrP = SNMP_ERR_NOERROR;
-
     laddr = oid2addr(&Var->name[LEN_SQ_MESH + 3]);
-
     for (p = Config.peers; p != NULL; p = p->next, cnt++)
 	if (p->in_addr.sin_addr.s_addr == laddr->s_addr)
 	    break;
-
     if (p == NULL) {
 	*ErrP = SNMP_ERR_NOSUCHNAME;
-	snmp_var_free(Answer);
-	return (NULL);
+	return NULL;
     }
     switch (Var->name[LEN_SQ_MESH + 2]) {
     case MESH_PTBL_NAME:
 	cp = p->host;
+	Answer = snmp_var_new(Var->name, Var->name_length);
 	Answer->type = ASN_OCTET_STR;
 	Answer->val_len = strlen(cp);
 	Answer->val.string = (u_char *) xstrdup(cp);
 	break;
     case MESH_PTBL_IP:
-	Answer->type = SMI_IPADDRESS;
-	Answer->val_len = sizeof(snint);
-	Answer->val.integer = xmalloc(Answer->val_len);
-	*(Answer->val.integer) = (snint) (p->in_addr.sin_addr.s_addr);
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    (snint) p->in_addr.sin_addr.s_addr,
+	    SMI_IPADDRESS);
 	break;
     case MESH_PTBL_HTTP:
-	Answer->val_len = sizeof(snint);
-	Answer->val.integer = xmalloc(Answer->val_len);
-	Answer->type = ASN_INTEGER;
-	*(Answer->val.integer) = (snint) p->http_port;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    (snint) p->http_port,
+	    ASN_INTEGER);
 	break;
     case MESH_PTBL_ICP:
-	Answer->val_len = sizeof(snint);
-	Answer->val.integer = xmalloc(Answer->val_len);
-	Answer->type = ASN_INTEGER;
-	*(Answer->val.integer) = (snint) p->icp.port;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    (snint) p->icp.port,
+	    ASN_INTEGER);
 	break;
     case MESH_PTBL_TYPE:
-	Answer->val_len = sizeof(snint);
-	Answer->val.integer = xmalloc(Answer->val_len);
-	Answer->type = ASN_INTEGER;
-	*(Answer->val.integer) = (snint) p->type;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    (snint) p->type,
+	    ASN_INTEGER);
 	break;
     case MESH_PTBL_STATE:
-	Answer->val_len = sizeof(snint);
-	Answer->val.integer = xmalloc(Answer->val_len);
-	Answer->type = ASN_INTEGER;
-	*(Answer->val.integer) = (snint) neighborUp(p);
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    (snint) neighborUp(p),
+	    ASN_INTEGER);
 	break;
     case MESH_PTBL_SENT:
-	Answer->val_len = sizeof(snint);
-	Answer->val.integer = xmalloc(Answer->val_len);
-	Answer->type = SMI_COUNTER32;
-	*(Answer->val.integer) = p->stats.pings_sent;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    p->stats.pings_sent,
+	    ASN_INTEGER);
 	break;
     case MESH_PTBL_PACKED:
-	Answer->val_len = sizeof(snint);
-	Answer->val.integer = xmalloc(Answer->val_len);
-	Answer->type = SMI_COUNTER32;
-	*(Answer->val.integer) = p->stats.pings_acked;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    p->stats.pings_acked,
+	    ASN_INTEGER);
 	break;
     case MESH_PTBL_FETCHES:
-	Answer->val_len = sizeof(snint);
-	Answer->val.integer = xmalloc(Answer->val_len);
-	Answer->type = SMI_COUNTER32;
-	*(Answer->val.integer) = p->stats.fetches;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    p->stats.fetches,
+	    SMI_COUNTER32);
 	break;
     case MESH_PTBL_RTT:
-	Answer->val_len = sizeof(snint);
-	Answer->val.integer = xmalloc(Answer->val_len);
-	Answer->type = ASN_INTEGER;
-	*(Answer->val.integer) = p->stats.rtt;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    p->stats.rtt,
+	    ASN_INTEGER);
 	break;
     case MESH_PTBL_IGN:
-	Answer->val_len = sizeof(snint);
-	Answer->val.integer = xmalloc(Answer->val_len);
-	Answer->type = SMI_COUNTER32;
-	*(Answer->val.integer) = p->stats.ignored_replies;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    p->stats.ignored_replies,
+	    SMI_COUNTER32);
 	break;
     case MESH_PTBL_KEEPAL_S:
-	Answer->val_len = sizeof(snint);
-	Answer->val.integer = xmalloc(Answer->val_len);
-	Answer->type = SMI_COUNTER32;
-	*(Answer->val.integer) = p->stats.n_keepalives_sent;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    p->stats.n_keepalives_sent,
+	    SMI_COUNTER32);
 	break;
     case MESH_PTBL_KEEPAL_R:
-	Answer->val_len = sizeof(snint);
-	Answer->val.integer = xmalloc(Answer->val_len);
-	Answer->type = SMI_COUNTER32;
-	*(Answer->val.integer) = p->stats.n_keepalives_recv;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    p->stats.n_keepalives_recv,
+	    SMI_COUNTER32);
 	break;
-
     default:
 	*ErrP = SNMP_ERR_NOSUCHNAME;
-	snmp_var_free(Answer);
-	return (NULL);
+	break;
     }
     return Answer;
 }
@@ -273,67 +239,77 @@
 variable_list *
 snmp_prfSysFn(variable_list * Var, snint * ErrP)
 {
-    variable_list *Answer;
+    variable_list *Answer = NULL;
     static struct rusage rusage;
-
     debug(49, 5) ("snmp_prfSysFn: Processing request with magic %d!\n", Var->name[LEN_SQ_PRF + 1]);
-
-    Answer = snmp_var_new(Var->name, Var->name_length);
     *ErrP = SNMP_ERR_NOERROR;
-    Answer->val_len = sizeof(snint);
-    Answer->val.integer = xmalloc(Answer->val_len);
-    Answer->type = ASN_INTEGER;
-
     switch (Var->name[LEN_SQ_PRF + 1]) {
     case PERF_SYS_PF:
 	squid_getrusage(&rusage);
-	*(Answer->val.integer) = rusage_pagefaults(&rusage);
-	Answer->type = SMI_COUNTER32;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    rusage_pagefaults(&rusage),
+	    SMI_COUNTER32);
 	break;
     case PERF_SYS_NUMR:
-	*(Answer->val.integer) = IOStats.Http.reads;
-	Answer->type = SMI_COUNTER32;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    IOStats.Http.reads,
+	    SMI_COUNTER32);
 	break;
     case PERF_SYS_MEMUSAGE:
-	*(Answer->val.integer) = (snint) memTotalAllocated() >> 10;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    (snint) memTotalAllocated() >> 10,
+	    ASN_INTEGER);
 	break;
     case PERF_SYS_CPUTIME:
 	squid_getrusage(&rusage);
-	*(Answer->val.integer) = (snint) rusage_cputime(&rusage);
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    (snint) rusage_cputime(&rusage),
+	    ASN_INTEGER);
 	break;
     case PERF_SYS_CPUUSAGE:
 	squid_getrusage(&rusage);
-	*(Answer->val.integer) = (snint)
-	    dpercent(rusage_cputime(&rusage), tvSubDsec(squid_start, current_time));
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    (snint) dpercent(rusage_cputime(&rusage), tvSubDsec(squid_start, current_time)),
+	    ASN_INTEGER);
 	break;
     case PERF_SYS_MAXRESSZ:
 	squid_getrusage(&rusage);
-	*(Answer->val.integer) = (snint) rusage_maxrss(&rusage);
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    (snint) rusage_maxrss(&rusage),
+	    ASN_INTEGER);
 	break;
     case PERF_SYS_CURLRUEXP:
-	Answer->type = SMI_TIMETICKS;
-	*(Answer->val.integer) = (snint) (storeExpiredReferenceAge() * 100);
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+#if !HEAP_REPLACEMENT
+	    (snint) (storeExpiredReferenceAge() * 100),
+#else
+	    0,
+#endif
+	    SMI_TIMETICKS);
 	break;
     case PERF_SYS_CURUNLREQ:
-	*(Answer->val.integer) = (snint) Counter.unlink.requests;
-	Answer->type = SMI_COUNTER32;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    (snint) Counter.unlink.requests,
+	    SMI_COUNTER32);
 	break;
     case PERF_SYS_CURUNUSED_FD:
-	*(Answer->val.integer) = (snint) Squid_MaxFD - Number_FD;
-	Answer->type = SMI_GAUGE32;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    (snint) Squid_MaxFD - Number_FD,
+	    SMI_GAUGE32);
 	break;
     case PERF_SYS_CURRESERVED_FD:
-	*(Answer->val.integer) = (snint) Number_FD;
-	Answer->type = SMI_GAUGE32;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    (snint) Number_FD,
+	    SMI_GAUGE32);
 	break;
     case PERF_SYS_NUMOBJCNT:
-	*(Answer->val.integer) = (snint) memInUse(MEM_STOREENTRY);
-	Answer->type = SMI_COUNTER32;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    (snint) memInUse(MEM_STOREENTRY),
+	    SMI_COUNTER32);
 	break;
     default:
 	*ErrP = SNMP_ERR_NOSUCHNAME;
-	snmp_var_free(Answer);
-	return (NULL);
+	break;
     }
     return Answer;
 }
@@ -341,94 +317,107 @@
 variable_list *
 snmp_prfProtoFn(variable_list * Var, snint * ErrP)
 {
-    variable_list *Answer;
+    variable_list *Answer = NULL;
     static StatCounters *f = NULL;
     static StatCounters *l = NULL;
     double x;
     int minutes;
-
     debug(49, 5) ("snmp_prfProtoFn: Processing request with magic %d!\n", Var->name[LEN_SQ_PRF]);
-
-    Answer = snmp_var_new(Var->name, Var->name_length);
     *ErrP = SNMP_ERR_NOERROR;
-
     switch (Var->name[LEN_SQ_PRF + 1]) {
     case PERF_PROTOSTAT_AGGR:	/* cacheProtoAggregateStats */
-	Answer->type = SMI_COUNTER32;
-	Answer->val_len = sizeof(snint);
-	Answer->val.integer = xmalloc(Answer->val_len);
 	switch (Var->name[LEN_SQ_PRF + 2]) {
 	case PERF_PROTOSTAT_AGGR_HTTP_REQ:
-	    *(Answer->val.integer) = (snint) Counter.client_http.requests;
+	    Answer = snmp_var_new_integer(Var->name, Var->name_length,
+		(snint) Counter.client_http.requests,
+		SMI_COUNTER32);
 	    break;
 	case PERF_PROTOSTAT_AGGR_HTTP_HITS:
-	    *(Answer->val.integer) = (snint) Counter.client_http.hits;
+	    Answer = snmp_var_new_integer(Var->name, Var->name_length,
+		(snint) Counter.client_http.hits,
+		SMI_COUNTER32);
 	    break;
 	case PERF_PROTOSTAT_AGGR_HTTP_ERRORS:
-	    *(Answer->val.integer) = (snint) Counter.client_http.errors;
+	    Answer = snmp_var_new_integer(Var->name, Var->name_length,
+		(snint) Counter.client_http.errors,
+		SMI_COUNTER32);
 	    break;
 	case PERF_PROTOSTAT_AGGR_HTTP_KBYTES_IN:
-	    *(Answer->val.integer) = (snint) Counter.client_http.kbytes_in.kb;
+	    Answer = snmp_var_new_integer(Var->name, Var->name_length,
+		(snint) Counter.client_http.kbytes_in.kb,
+		SMI_COUNTER32);
 	    break;
 	case PERF_PROTOSTAT_AGGR_HTTP_KBYTES_OUT:
-	    *(Answer->val.integer) = (snint) Counter.client_http.kbytes_out.kb;
+	    Answer = snmp_var_new_integer(Var->name, Var->name_length,
+		(snint) Counter.client_http.kbytes_out.kb,
+		SMI_COUNTER32);
 	    break;
 	case PERF_PROTOSTAT_AGGR_ICP_S:
-	    *(Answer->val.integer) = (snint) Counter.icp.pkts_sent;
+	    Answer = snmp_var_new_integer(Var->name, Var->name_length,
+		(snint) Counter.icp.pkts_sent,
+		SMI_COUNTER32);
 	    break;
 	case PERF_PROTOSTAT_AGGR_ICP_R:
-	    *(Answer->val.integer) = (snint) Counter.icp.pkts_recv;
+	    Answer = snmp_var_new_integer(Var->name, Var->name_length,
+		(snint) Counter.icp.pkts_recv,
+		SMI_COUNTER32);
 	    break;
 	case PERF_PROTOSTAT_AGGR_ICP_SKB:
-	    *(Answer->val.integer) = (snint) Counter.icp.kbytes_sent.kb;
+	    Answer = snmp_var_new_integer(Var->name, Var->name_length,
+		(snint) Counter.icp.kbytes_sent.kb,
+		SMI_COUNTER32);
 	    break;
 	case PERF_PROTOSTAT_AGGR_ICP_RKB:
-	    *(Answer->val.integer) = (snint) Counter.icp.kbytes_recv.kb;
+	    Answer = snmp_var_new_integer(Var->name, Var->name_length,
+		(snint) Counter.icp.kbytes_recv.kb,
+		SMI_COUNTER32);
 	    break;
 	case PERF_PROTOSTAT_AGGR_REQ:
-	    *(Answer->val.integer) = (snint) Counter.server.all.requests;
-	    Answer->type = SMI_INTEGER;
+	    Answer = snmp_var_new_integer(Var->name, Var->name_length,
+		(snint) Counter.server.all.requests,
+		SMI_INTEGER);
 	    break;
 	case PERF_PROTOSTAT_AGGR_ERRORS:
-	    *(Answer->val.integer) = (snint) Counter.server.all.errors;
-	    Answer->type = SMI_INTEGER;
+	    Answer = snmp_var_new_integer(Var->name, Var->name_length,
+		(snint) Counter.server.all.errors,
+		SMI_INTEGER);
 	    break;
 	case PERF_PROTOSTAT_AGGR_KBYTES_IN:
-	    *(Answer->val.integer) = (snint) Counter.server.all.kbytes_in.kb;
+	    Answer = snmp_var_new_integer(Var->name, Var->name_length,
+		(snint) Counter.server.all.kbytes_in.kb,
+		SMI_COUNTER32);
 	    break;
 	case PERF_PROTOSTAT_AGGR_KBYTES_OUT:
-	    *(Answer->val.integer) = (snint) Counter.server.all.kbytes_out.kb;
+	    Answer = snmp_var_new_integer(Var->name, Var->name_length,
+		(snint) Counter.server.all.kbytes_out.kb,
+		SMI_COUNTER32);
 	    break;
 	case PERF_PROTOSTAT_AGGR_CURSWAP:
-	    *(Answer->val.integer) = (snint) store_swap_size;
+	    Answer = snmp_var_new_integer(Var->name, Var->name_length,
+		(snint) store_swap_size,
+		SMI_COUNTER32);
 	    break;
 	case PERF_PROTOSTAT_AGGR_CLIENTS:
-	    *(Answer->val.integer) = (snint) Counter.client_http.clients;
+	    Answer = snmp_var_new_integer(Var->name, Var->name_length,
+		(snint) Counter.client_http.clients,
+		SMI_COUNTER32);
 	    break;
 	default:
 	    *ErrP = SNMP_ERR_NOSUCHNAME;
-	    snmp_var_free(Answer);
-	    return (NULL);
+	    break;
 	}
 	return Answer;
     case PERF_PROTOSTAT_MEDIAN:
-
 	if (Var->name_length == LEN_SQ_PRF + 5)
 	    minutes = Var->name[LEN_SQ_PRF + 4];
 	else
 	    break;
 	if ((minutes < 1) || (minutes > 60))
 	    break;
-
 	f = snmpStatGet(0);
 	l = snmpStatGet(minutes);
-
 	debug(49, 8) ("median: min= %d, %d l= %x , f = %x\n", minutes,
 	    Var->name[LEN_SQ_PRF + 3], l, f);
-	Answer->type = SMI_INTEGER;
-	Answer->val_len = sizeof(snint);
-	Answer->val.integer = xmalloc(Answer->val_len);
-
 	debug(49, 8) ("median: l= %x , f = %x\n", l, f);
 	switch (Var->name[LEN_SQ_PRF + 3]) {
 	case PERF_MEDIAN_TIME:
@@ -467,13 +456,12 @@
 	    break;
 	default:
 	    *ErrP = SNMP_ERR_NOSUCHNAME;
-	    snmp_var_free(Answer);
-	    return (NULL);
+	    return NULL;
 	}
-	*(Answer->val.integer) = (snint) x;
-	return Answer;
+	return snmp_var_new_integer(Var->name, Var->name_length,
+	    (snint) x,
+	    SMI_INTEGER);
     }
     *ErrP = SNMP_ERR_NOSUCHNAME;
-    snmp_var_free(Answer);
-    return (NULL);
+    return NULL;
 }
Index: squid/src/snmp_core.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/snmp_core.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/snmp_core.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/snmp_core.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: snmp_core.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: snmp_core.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 49    SNMP support
  * AUTHOR: Glenn Chisholm
@@ -483,7 +483,7 @@
 /*
  * Turn SNMP packet into a PDU, check available ACL's
  */
-void
+static void
 snmpDecodePacket(snmp_request_t * rq)
 {
     struct snmp_pdu *PDU;
@@ -519,7 +519,7 @@
 /*
  * Packet OK, ACL Check OK, Create reponse.
  */
-void
+static void
 snmpConstructReponse(snmp_request_t * rq)
 {
     struct snmp_session Session;
@@ -546,7 +546,7 @@
  * 
  * If configured forward any reponses which are not for this agent.
  */
-struct snmp_pdu *
+static struct snmp_pdu *
 snmpAgentResponse(struct snmp_pdu *PDU)
 {
     struct snmp_pdu *Answer = NULL;
@@ -632,7 +632,7 @@
     return (Answer);
 }
 
-oid_ParseFn *
+static oid_ParseFn *
 snmpTreeGet(oid * Current, snint CurrentLen)
 {
     oid_ParseFn *Fn = NULL;
@@ -659,7 +659,7 @@
     return (Fn);
 }
 
-oid_ParseFn *
+static oid_ParseFn *
 snmpTreeNext(oid * Current, snint CurrentLen, oid ** Next, snint * NextLen)
 {
     oid_ParseFn *Fn = NULL;
@@ -725,7 +725,7 @@
     return (Fn);
 }
 
-oid *
+static oid *
 static_Inst(oid * name, snint * len, mib_tree_entry * current, oid_ParseFn ** Fn)
 {
     oid *instance = NULL;
@@ -740,7 +740,7 @@
     return (instance);
 }
 
-oid *
+static oid *
 time_Inst(oid * name, snint * len, mib_tree_entry * current, oid_ParseFn ** Fn)
 {
     oid *instance = NULL;
@@ -767,7 +767,7 @@
     return (instance);
 }
 
-oid *
+static oid *
 peer_Inst(oid * name, snint * len, mib_tree_entry * current, oid_ParseFn ** Fn)
 {
     oid *instance = NULL;
@@ -826,7 +826,7 @@
     return (instance);
 }
 
-oid *
+static oid *
 client_Inst(oid * name, snint * len, mib_tree_entry * current, oid_ParseFn ** Fn)
 {
     oid *instance = NULL;
@@ -874,7 +874,7 @@
 /* 
  * Returns a the sibling object in the tree
  */
-mib_tree_entry *
+static mib_tree_entry *
 snmpTreeSiblingEntry(oid entry, snint len, mib_tree_entry * current)
 {
     mib_tree_entry *next = NULL;
@@ -897,7 +897,7 @@
 /* 
  * Returns the requested child object or NULL if it does not exist
  */
-mib_tree_entry *
+static mib_tree_entry *
 snmpTreeEntry(oid entry, snint len, mib_tree_entry * current)
 {
     mib_tree_entry *next = NULL;
@@ -915,7 +915,7 @@
 /*
  * Adds a node to the MIB tree structure and adds the appropriate children
  */
-mib_tree_entry *
+static mib_tree_entry *
 #if STDC_HEADERS
 snmpAddNode(oid * name, int len, oid_ParseFn * parsefunction, instance_Fn * instancefunction, int children,...)
 #else
@@ -968,7 +968,7 @@
 /* 
  * Returns the list of parameters in an oid
  */
-oid *
+static oid *
 #if STDC_HEADERS
 snmpCreateOid(int length,...)
 #else
@@ -1002,7 +1002,7 @@
 /*
  * Allocate space for, and copy, an OID.  Returns new oid.
  */
-oid *
+static oid *
 snmpOidDup(oid * A, snint ALen)
 {
     oid *Ans = xmalloc(sizeof(oid) * ALen);
Index: squid/src/squid.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/squid.h,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/squid.h	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/squid.h	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: squid.h,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: squid.h,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * AUTHOR: Duane Wessels
  *
@@ -51,10 +51,12 @@
 #define CHANGE_FD_SETSIZE 0
 #endif
 
-/* Cannot increase FD_SETSIZE on FreeBSD before 2.2.0, causes select(2)
- * to return EINVAL. */
-/* Marian Durkovic <marian@svf.stuba.sk> */
-/* Peter Wemm <peter@spinner.DIALix.COM> */
+/*
+ * Cannot increase FD_SETSIZE on FreeBSD before 2.2.0, causes select(2)
+ * to return EINVAL.
+ * --Marian Durkovic <marian@svf.stuba.sk>
+ * --Peter Wemm <peter@spinner.DIALix.COM>
+ */
 #if defined(_SQUID_FREEBSD_)
 #include <osreldate.h>
 #if __FreeBSD_version < 220000
@@ -63,6 +65,15 @@
 #endif
 #endif
 
+/*
+ * Trying to redefine CHANGE_FD_SETSIZE causes a slew of warnings
+ * on Mac OS X Server.
+ */
+#if defined(_SQUID_APPLE_)
+#undef CHANGE_FD_SETSIZE
+#define CHANGE_FD_SETSIZE 0
+#endif
+
 /* Increase FD_SETSIZE if SQUID_MAXFD is bigger */
 #if CHANGE_FD_SETSIZE && SQUID_MAXFD > DEFAULT_FD_SETSIZE
 #define FD_SETSIZE SQUID_MAXFD
@@ -175,6 +186,9 @@
 #if HAVE_GETOPT_H
 #include <getopt.h>
 #endif
+#if HAVE_LIMITS_H
+#include <limits.h>
+#endif
 
 #if HAVE_DIRENT_H
 #include <dirent.h>
@@ -222,6 +236,7 @@
 #ifdef HAVE_SYSLOG_H
 #ifdef _SQUID_AIX_
 #define _XOPEN_EXTENDED_SOURCE
+#define _XOPEN_SOURCE_EXTENDED 1
 #endif
 #include <syslog.h>
 #endif
@@ -344,6 +359,10 @@
 #endif
 
 #include "hash.h"
+#include "rfc1035.h"
+#if HEAP_REPLACEMENT
+#include "heap.h"
+#endif
 
 #include "defines.h"
 #include "enums.h"
@@ -353,7 +372,14 @@
 #include "globals.h"
 
 #include "util.h"
+
+/*
+ * Mac OS X Server already has radix.h as a standard header, so
+ * this causes conflicts.
+ */
+#ifndef _SQUID_APPLE_
 #include "radix.h"
+#endif
 
 #if !HAVE_TEMPNAM
 #include "tempnam.h"
@@ -385,9 +411,17 @@
 #define strdup +
 #endif
 
-#if SQUID_SNMP
-extern struct snmp_mib_tree *Mib;
+/*
+ * Hey dummy, don't be tempted to move this to lib/config.h.in again.  O_NONBLOCK
+ * will not be defined there because you didn't #include <fcntl.h> yet.
+ */
+#if defined(O_NONBLOCK) && !defined(_SQUID_SUNOS_) && !defined(_SQUID_SOLARIS_)
+#define SQUID_NONBLOCK O_NONBLOCK
+#else
+#define SQUID_NONBLOCK O_NDELAY
 #endif
 
+#define SWAP_DIR_SHIFT 24
+#define SWAP_FILE_MASK 0x00FFFFFF
 
 #endif /* SQUID_H */
Index: squid/src/ssl.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/ssl.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/ssl.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/ssl.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ssl.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: ssl.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 26    Secure Sockets Layer Proxy
  * AUTHOR: Duane Wessels
@@ -119,7 +119,12 @@
 sslDeferServerRead(int fdnotused, void *data)
 {
     SslStateData *s = data;
-    return delayBytesWanted(s->delay_id, 0, 1) == 0;
+    int i = delayBytesWanted(s->delay_id, 0, INT_MAX);
+    if (i == INT_MAX)
+	return 0;
+    if (i == 0)
+	return 1;
+    return -1;
 }
 #endif
 
@@ -155,7 +160,8 @@
 		0);
 	}
 #if DELAY_POOLS
-	/* If this was allowed to return 0, there would be a possibility
+	/*
+	 * If this was allowed to return 0, there would be a possibility
 	 * of the socket becoming "hung" with data accumulating but no
 	 * write handler (server.len==0) and no read handler (!(0<0)) and
 	 * no data flowing in the other direction.  Hence the argument of
@@ -206,8 +212,8 @@
     }
     cbdataLock(sslState);
     if (len < 0) {
-	debug(50, 1) ("sslReadServer: FD %d: read failure: %s\n",
-	    fd, xstrerror());
+	debug(50, ignoreErrno(errno) ? 3 : 1)
+	    ("sslReadServer: FD %d: read failure: %s\n", fd, xstrerror());
 	if (!ignoreErrno(errno))
 	    comm_close(fd);
     } else if (len == 0) {
@@ -240,7 +246,7 @@
     }
     cbdataLock(sslState);
     if (len < 0) {
-	debug(50, 1) ("sslReadClient: FD %d: read failure: %s\n",
+	debug(50, ECONNRESET == errno ? 3 : 1) ("sslReadClient: FD %d: read failure: %s\n",
 	    fd, xstrerror());
 	if (!ignoreErrno(errno))
 	    comm_close(fd);
@@ -281,8 +287,8 @@
     }
     cbdataLock(sslState);
     if (len < 0) {
-	debug(50, 1) ("sslWriteServer: FD %d: write failure: %s.\n",
-	    fd, xstrerror());
+	debug(50, ignoreErrno(errno) ? 3 : 1)
+	    ("sslWriteServer: FD %d: write failure: %s.\n", fd, xstrerror());
 	if (!ignoreErrno(errno))
 	    comm_close(fd);
     }
@@ -322,8 +328,8 @@
     }
     cbdataLock(sslState);
     if (len < 0) {
-	debug(50, 1) ("sslWriteClient: FD %d: write failure: %s.\n",
-	    fd, xstrerror());
+	debug(50, ignoreErrno(errno) ? 3 : 1)
+	    ("sslWriteClient: FD %d: write failure: %s.\n", fd, xstrerror());
 	if (!ignoreErrno(errno))
 	    comm_close(fd);
     }
@@ -527,6 +533,12 @@
     } else {
 	sslState->port = CACHE_HTTP_PORT;
     }
+    if (fs->peer) {
+	sslState->request->peer_login = fs->peer->login;
+	sslState->request->flags.proxying = 1;
+    } else {
+	sslState->request->flags.proxying = 0;
+    }
 #if DELAY_POOLS
     /* no point using the delayIsNoDelay stuff since ssl is nice and simple */
     if (g && g->options.no_delay && sslState->delay_id) {
